// HaskellProxy.cpp : Implementation of CHaskellProxy

#include "stdafx.h"
#include "HaskellProxy.h"

extern "C" {
	char* hString2String(char*);
	void  hFreeString(char*);
}

// CHaskellProxy

// A function that passes a string to Haskell and
// returns the string that came from Haskell
STDMETHODIMP CHaskellProxy::string2string(BSTR* inString, VARIANT* result)
{
	// Convert a BSTR to a C-style Ascii string
	CComBSTR inStr(*inString);
	CW2A inAscii(inStr);

	// Invoke the Haskell function
	char* haskellResult = hString2String(inAscii);

	// Convert the returned string to VARIANT
	CComBSTR bstr(haskellResult);
	CComVariant var(bstr);

	// Clean up the string returned from Haskell
	hFreeString(haskellResult);

	// Detach the return value and exit
	var.Detach(result);
	return S_OK;
}
